diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
new file mode 100644
index d10fb4e..c1e74c0
*** a/src/backend/access/heap/heapam.c
--- b/src/backend/access/heap/heapam.c
***************
*** 56,61 ****
--- 56,62 ----
  #include "access/xlogutils.h"
  #include "catalog/catalog.h"
  #include "catalog/namespace.h"
+ #include "commands/vacuum.h"
  #include "miscadmin.h"
  #include "pgstat.h"
  #include "storage/bufmgr.h"
*************** static HeapScanDesc heap_beginscan_inter
*** 91,97 ****
  						bool temp_snap);
  static BlockNumber heap_parallelscan_nextpage(HeapScanDesc scan);
  static HeapTuple heap_prepare_insert(Relation relation, HeapTuple tup,
! 					TransactionId xid, CommandId cid, int options);
  static XLogRecPtr log_heap_update(Relation reln, Buffer oldbuf,
  				Buffer newbuf, HeapTuple oldtup,
  				HeapTuple newtup, HeapTuple old_key_tup,
--- 92,98 ----
  						bool temp_snap);
  static BlockNumber heap_parallelscan_nextpage(HeapScanDesc scan);
  static HeapTuple heap_prepare_insert(Relation relation, HeapTuple tup,
! 					CommandId cid, int options);
  static XLogRecPtr log_heap_update(Relation reln, Buffer oldbuf,
  				Buffer newbuf, HeapTuple oldtup,
  				HeapTuple newtup, HeapTuple old_key_tup,
*************** heapgetpage(HeapScanDesc scan, BlockNumb
*** 431,436 ****
--- 432,438 ----
  			loctup.t_tableOid = RelationGetRelid(scan->rs_rd);
  			loctup.t_data = (HeapTupleHeader) PageGetItem((Page) dp, lpp);
  			loctup.t_len = ItemIdGetLength(lpp);
+ 			HeapTupleCopyBaseFromPage(&loctup, dp);
  			ItemPointerSet(&(loctup.t_self), page, lineoff);
  
  			if (all_visible)
*************** heapgettup(HeapScanDesc scan,
*** 625,630 ****
--- 627,633 ----
  
  		tuple->t_data = (HeapTupleHeader) PageGetItem((Page) dp, lpp);
  		tuple->t_len = ItemIdGetLength(lpp);
+ 		HeapTupleCopyBaseFromPage(tuple, dp);
  
  		return;
  	}
*************** heapgettup(HeapScanDesc scan,
*** 644,649 ****
--- 647,653 ----
  
  				tuple->t_data = (HeapTupleHeader) PageGetItem((Page) dp, lpp);
  				tuple->t_len = ItemIdGetLength(lpp);
+ 				HeapTupleCopyBaseFromPage(tuple, dp);
  				ItemPointerSet(&(tuple->t_self), page, lineoff);
  
  				/*
*************** heapgettup_pagemode(HeapScanDesc scan,
*** 921,926 ****
--- 925,931 ----
  
  		tuple->t_data = (HeapTupleHeader) PageGetItem((Page) dp, lpp);
  		tuple->t_len = ItemIdGetLength(lpp);
+ 		HeapTupleCopyBaseFromPage(tuple, dp);
  
  		/* check that rs_cindex is in sync */
  		Assert(scan->rs_cindex < scan->rs_ntuples);
*************** heapgettup_pagemode(HeapScanDesc scan,
*** 943,948 ****
--- 948,954 ----
  
  			tuple->t_data = (HeapTupleHeader) PageGetItem((Page) dp, lpp);
  			tuple->t_len = ItemIdGetLength(lpp);
+ 			HeapTupleCopyBaseFromPage(tuple, dp);
  			ItemPointerSet(&(tuple->t_self), page, lineoff);
  
  			/*
*************** heap_fetch(Relation relation,
*** 1932,1937 ****
--- 1938,1944 ----
  	tuple->t_data = (HeapTupleHeader) PageGetItem(page, lp);
  	tuple->t_len = ItemIdGetLength(lp);
  	tuple->t_tableOid = RelationGetRelid(relation);
+ 	HeapTupleCopyBaseFromPage(tuple, page);
  
  	/*
  	 * check time qualification of tuple, then release lock
*************** heap_hot_search_buffer(ItemPointer tid, 
*** 2017,2022 ****
--- 2024,2030 ----
  	skip = !first_call;
  
  	heapTuple->t_self = *tid;
+ 	HeapTupleCopyBaseFromPage(heapTuple, dp);
  
  	/* Scan through possible multiple members of HOT-chain */
  	for (;;)
*************** heap_hot_search_buffer(ItemPointer tid, 
*** 2047,2052 ****
--- 2055,2061 ----
  		heapTuple->t_data = (HeapTupleHeader) PageGetItem(dp, lp);
  		heapTuple->t_len = ItemIdGetLength(lp);
  		heapTuple->t_tableOid = RelationGetRelid(relation);
+ 		HeapTupleCopyBaseFromPage(heapTuple, dp);
  		ItemPointerSetOffsetNumber(&heapTuple->t_self, offnum);
  
  		/*
*************** heap_hot_search_buffer(ItemPointer tid, 
*** 2061,2067 ****
  		 */
  		if (TransactionIdIsValid(prev_xmax) &&
  			!TransactionIdEquals(prev_xmax,
! 								 HeapTupleHeaderGetXmin(heapTuple->t_data)))
  			break;
  
  		/*
--- 2070,2076 ----
  		 */
  		if (TransactionIdIsValid(prev_xmax) &&
  			!TransactionIdEquals(prev_xmax,
! 								 HeapTupleGetXmin(heapTuple)))
  			break;
  
  		/*
*************** heap_hot_search_buffer(ItemPointer tid, 
*** 2119,2125 ****
  				   ItemPointerGetBlockNumber(tid));
  			offnum = ItemPointerGetOffsetNumber(&heapTuple->t_data->t_ctid);
  			at_chain_start = false;
! 			prev_xmax = HeapTupleHeaderGetUpdateXid(heapTuple->t_data);
  		}
  		else
  			break;				/* end of chain */
--- 2128,2134 ----
  				   ItemPointerGetBlockNumber(tid));
  			offnum = ItemPointerGetOffsetNumber(&heapTuple->t_data->t_ctid);
  			at_chain_start = false;
! 			prev_xmax = HeapTupleGetUpdateXidAny(heapTuple);
  		}
  		else
  			break;				/* end of chain */
*************** heap_get_latest_tid(Relation relation,
*** 2238,2250 ****
  		tp.t_data = (HeapTupleHeader) PageGetItem(page, lp);
  		tp.t_len = ItemIdGetLength(lp);
  		tp.t_tableOid = RelationGetRelid(relation);
  
  		/*
  		 * After following a t_ctid link, we might arrive at an unrelated
  		 * tuple.  Check for XMIN match.
  		 */
  		if (TransactionIdIsValid(priorXmax) &&
! 		  !TransactionIdEquals(priorXmax, HeapTupleHeaderGetXmin(tp.t_data)))
  		{
  			UnlockReleaseBuffer(buffer);
  			break;
--- 2247,2260 ----
  		tp.t_data = (HeapTupleHeader) PageGetItem(page, lp);
  		tp.t_len = ItemIdGetLength(lp);
  		tp.t_tableOid = RelationGetRelid(relation);
+ 		HeapTupleCopyBaseFromPage(&tp, page);
  
  		/*
  		 * After following a t_ctid link, we might arrive at an unrelated
  		 * tuple.  Check for XMIN match.
  		 */
  		if (TransactionIdIsValid(priorXmax) &&
! 		  !TransactionIdEquals(priorXmax, HeapTupleGetXmin(&tp)))
  		{
  			UnlockReleaseBuffer(buffer);
  			break;
*************** heap_get_latest_tid(Relation relation,
*** 2263,2269 ****
  		 * If there's a valid t_ctid link, follow it, else we're done.
  		 */
  		if ((tp.t_data->t_infomask & HEAP_XMAX_INVALID) ||
! 			HeapTupleHeaderIsOnlyLocked(tp.t_data) ||
  			ItemPointerEquals(&tp.t_self, &tp.t_data->t_ctid))
  		{
  			UnlockReleaseBuffer(buffer);
--- 2273,2279 ----
  		 * If there's a valid t_ctid link, follow it, else we're done.
  		 */
  		if ((tp.t_data->t_infomask & HEAP_XMAX_INVALID) ||
! 			HeapTupleHeaderIsOnlyLocked(&tp) ||
  			ItemPointerEquals(&tp.t_self, &tp.t_data->t_ctid))
  		{
  			UnlockReleaseBuffer(buffer);
*************** heap_get_latest_tid(Relation relation,
*** 2271,2277 ****
  		}
  
  		ctid = tp.t_data->t_ctid;
! 		priorXmax = HeapTupleHeaderGetUpdateXid(tp.t_data);
  		UnlockReleaseBuffer(buffer);
  	}							/* end of loop */
  }
--- 2281,2287 ----
  		}
  
  		ctid = tp.t_data->t_ctid;
! 		priorXmax = HeapTupleGetUpdateXidAny(&tp);
  		UnlockReleaseBuffer(buffer);
  	}							/* end of loop */
  }
*************** heap_get_latest_tid(Relation relation,
*** 2296,2302 ****
  static void
  UpdateXmaxHintBits(HeapTupleHeader tuple, Buffer buffer, TransactionId xid)
  {
! 	Assert(TransactionIdEquals(HeapTupleHeaderGetRawXmax(tuple), xid));
  	Assert(!(tuple->t_infomask & HEAP_XMAX_IS_MULTI));
  
  	if (!(tuple->t_infomask & (HEAP_XMAX_COMMITTED | HEAP_XMAX_INVALID)))
--- 2306,2312 ----
  static void
  UpdateXmaxHintBits(HeapTupleHeader tuple, Buffer buffer, TransactionId xid)
  {
! 	Assert(TransactionIdEquals(HeapTupleHeaderGetRawXmax(BufferGetPage(buffer), tuple), xid));
  	Assert(!(tuple->t_infomask & HEAP_XMAX_IS_MULTI));
  
  	if (!(tuple->t_infomask & (HEAP_XMAX_COMMITTED | HEAP_XMAX_INVALID)))
*************** heap_insert(Relation relation, HeapTuple
*** 2409,2415 ****
  	 * Note: below this point, heaptup is the data we actually intend to store
  	 * into the relation; tup is the caller's original untoasted data.
  	 */
! 	heaptup = heap_prepare_insert(relation, tup, xid, cid, options);
  
  	/*
  	 * Find buffer to insert this tuple into.  If the page is all visible,
--- 2419,2425 ----
  	 * Note: below this point, heaptup is the data we actually intend to store
  	 * into the relation; tup is the caller's original untoasted data.
  	 */
! 	heaptup = heap_prepare_insert(relation, tup, cid, options);
  
  	/*
  	 * Find buffer to insert this tuple into.  If the page is all visible,
*************** heap_insert(Relation relation, HeapTuple
*** 2436,2446 ****
  	 */
  	CheckForSerializableConflictIn(relation, NULL, InvalidBuffer);
  
  	/* NO EREPORT(ERROR) from here till changes are logged */
  	START_CRIT_SECTION();
  
  	RelationPutHeapTuple(relation, buffer, heaptup,
! 						 (options & HEAP_INSERT_SPECULATIVE) != 0);
  
  	if (PageIsAllVisible(BufferGetPage(buffer)))
  	{
--- 2446,2459 ----
  	 */
  	CheckForSerializableConflictIn(relation, NULL, InvalidBuffer);
  
+ 	heap_page_prepare_for_xid(relation, buffer, xid, false);
+ 	HeapTupleCopyBaseFromPage(heaptup, BufferGetPage(buffer));
+ 
  	/* NO EREPORT(ERROR) from here till changes are logged */
  	START_CRIT_SECTION();
  
  	RelationPutHeapTuple(relation, buffer, heaptup,
! 						 (options & HEAP_INSERT_SPECULATIVE) != 0, xid);
  
  	if (PageIsAllVisible(BufferGetPage(buffer)))
  	{
*************** heap_insert(Relation relation, HeapTuple
*** 2513,2518 ****
--- 2526,2535 ----
  		}
  
  		XLogBeginInsert();
+ 		if (info & XLOG_HEAP_INIT_PAGE)
+ 		{
+ 			XLogRegisterData((char *) &HeapPageGetSpecial(page)->pd_xid_base, sizeof(TransactionId));
+ 		}
  		XLogRegisterData((char *) &xlrec, SizeOfHeapInsert);
  
  		xlhdr.t_infomask2 = heaptup->t_data->t_infomask2;
*************** heap_insert(Relation relation, HeapTuple
*** 2570,2575 ****
--- 2587,3018 ----
  }
  
  /*
+  * Find minimum and maximum short transaction ids which occurs in the page.
+  */
+ static bool
+ heap_page_xid_min_max(Page page, bool multi,
+ 					  ShortTransactionId *min,
+ 					  ShortTransactionId *max)
+ {
+ 	bool				found = false;
+ 	OffsetNumber		offnum,
+ 						maxoff;
+ 
+ 	maxoff = PageGetMaxOffsetNumber(page);
+ 
+ 	for (offnum = FirstOffsetNumber;
+ 		 offnum <= maxoff;
+ 		 offnum = OffsetNumberNext(offnum))
+ 	{
+ 		ItemId				itemid;
+ 		HeapTupleHeader		htup;
+ 
+ 		itemid = PageGetItemId(page, offnum);
+ 
+ 		if (!ItemIdIsNormal(itemid))
+ 			continue;
+ 
+ 		htup = (HeapTupleHeader) PageGetItem(page, itemid);
+ 
+ 		if (!multi)
+ 		{
+ 			if (!HeapTupleHeaderXminFrozen(htup) &&
+ 				TransactionIdIsNormal(htup->t_choice.t_heap.t_xmin))
+ 			{
+ 				if (!found)
+ 				{
+ 					*min = *max = htup->t_choice.t_heap.t_xmin;
+ 					found = true;
+ 				}
+ 				else
+ 				{
+ 					*min = Min(*min, htup->t_choice.t_heap.t_xmin);
+ 					*max = Max(*max, htup->t_choice.t_heap.t_xmin);
+ 				}
+ 			}
+ 
+ 			if (TransactionIdIsNormal(htup->t_choice.t_heap.t_xmax) &&
+ 				!(htup->t_infomask & HEAP_XMAX_IS_MULTI))
+ 			{
+ 				if (!found)
+ 				{
+ 					*min = *max = htup->t_choice.t_heap.t_xmax;
+ 					found = true;
+ 				}
+ 				else
+ 				{
+ 					*min = Min(*min, htup->t_choice.t_heap.t_xmax);
+ 					*max = Max(*max, htup->t_choice.t_heap.t_xmax);
+ 				}
+ 			}
+ 		}
+ 		else
+ 		{
+ 			if (TransactionIdIsNormal(htup->t_choice.t_heap.t_xmax) &&
+ 				(htup->t_infomask & HEAP_XMAX_IS_MULTI))
+ 			{
+ 				if (!found)
+ 				{
+ 					*min = *max = htup->t_choice.t_heap.t_xmax;
+ 					found = true;
+ 				}
+ 				else
+ 				{
+ 					*min = Min(*min, htup->t_choice.t_heap.t_xmax);
+ 					*max = Max(*max, htup->t_choice.t_heap.t_xmax);
+ 				}
+ 			}
+ 		}
+ 	}
+ 	return found;
+ }
+ 
+ /*
+  * Shift xid base in the page.  WAL-logged if buffer is specified.
+  */
+ static void
+ heap_page_shift_base(Buffer buffer, Page page, bool multi, int64 delta)
+ {
+ 	HeapPageSpecial		pageSpecial = HeapPageGetSpecial(page);
+ 	OffsetNumber		offnum,
+ 						maxoff;
+ 
+ 	/* Iterate over page items */
+ 	maxoff = PageGetMaxOffsetNumber(page);
+ 	for (offnum = FirstOffsetNumber;
+ 		 offnum <= maxoff;
+ 		 offnum = OffsetNumberNext(offnum))
+ 	{
+ 		ItemId				itemid;
+ 		HeapTupleHeader		htup;
+ 
+ 		itemid = PageGetItemId(page, offnum);
+ 
+ 		if (!ItemIdIsNormal(itemid))
+ 			continue;
+ 
+ 		htup = (HeapTupleHeader) PageGetItem(page, itemid);
+ 
+ 		/* Apply xid shift to heap tuple */
+ 		if (!multi)
+ 		{
+ 			if (!HeapTupleHeaderXminFrozen(htup) &&
+ 				TransactionIdIsNormal(htup->t_choice.t_heap.t_xmin))
+ 			{
+ 				Assert(htup->t_choice.t_heap.t_xmin - delta >= FirstNormalTransactionId);
+ 				Assert(htup->t_choice.t_heap.t_xmin - delta <= MaxShortTransactionId);
+ 				htup->t_choice.t_heap.t_xmin -= delta;
+ 			}
+ 
+ 			if (TransactionIdIsNormal(htup->t_choice.t_heap.t_xmax) &&
+ 				!(htup->t_infomask & HEAP_XMAX_IS_MULTI))
+ 			{
+ 				Assert(htup->t_choice.t_heap.t_xmax - delta >= FirstNormalTransactionId);
+ 				Assert(htup->t_choice.t_heap.t_xmax - delta <= MaxShortTransactionId);
+ 				htup->t_choice.t_heap.t_xmax -= delta;
+ 			}
+ 		}
+ 		else
+ 		{
+ 			if (TransactionIdIsNormal(htup->t_choice.t_heap.t_xmax) &&
+ 				(htup->t_infomask & HEAP_XMAX_IS_MULTI))
+ 			{
+ 				Assert(htup->t_choice.t_heap.t_xmax - delta >= FirstNormalTransactionId);
+ 				Assert(htup->t_choice.t_heap.t_xmax - delta <= MaxShortTransactionId);
+ 				htup->t_choice.t_heap.t_xmax -= delta;
+ 			}
+ 		}
+ 	}
+ 
+ 	/* Apply xid shift to base as well */
+ 	if (!multi)
+ 		pageSpecial->pd_xid_base += delta;
+ 	else
+ 		pageSpecial->pd_multi_base += delta;
+ 
+ 	/* Write WAL record if needed */
+ 	if (BufferIsValid(buffer))
+ 	{
+ 		XLogRecPtr			recptr;
+ 		xl_heap_base_shift	xlrec;
+ 
+ 		xlrec.multi = multi;
+ 		xlrec.delta = delta;
+ 
+ 		XLogBeginInsert();
+ 		XLogRegisterData((char *) &xlrec, SizeOfHeapBaseShift);
+ 
+ 		XLogRegisterBuffer(0, buffer, REGBUF_STANDARD);
+ 
+ 		recptr = XLogInsert(RM_HEAP_ID, XLOG_HEAP_BASE_SHIFT);
+ 
+ 		PageSetLSN(page, recptr);
+ 	}
+ }
+ 
+ /*
+  * Freeze xids in the single heap page.  Useful when we can't fit new xid even
+  * with base shift.
+  */
+ static int
+ freeze_single_heap_page(Relation relation, Buffer buffer)
+ {
+ 	Page					page = BufferGetPage(buffer);
+ 	OffsetNumber			offnum,
+ 							maxoff;
+ 	HeapTupleData			tuple;
+ 	int						nfrozen = 0;
+ 	xl_heap_freeze_tuple   *frozen;
+ 	TransactionId			latestRemovedXid = InvalidTransactionId,
+ 							OldestXmin,
+ 							FreezeXid;
+ 	MultiXactId				MultiXactCutoff;
+ 
+ 	vacuum_set_xid_limits(relation, 0, 0, 0, 0,
+ 						  &OldestXmin, &FreezeXid, NULL, &MultiXactCutoff,
+ 						  NULL);
+ 
+ 	heap_page_prune(relation, buffer, OldestXmin, false, &latestRemovedXid, false);
+ 
+ 	/*
+ 	 * Now scan the page to collect vacuumable items and check for tuples
+ 	 * requiring freezing.
+ 	 */
+ 	maxoff = PageGetMaxOffsetNumber(page);
+ 	frozen = palloc(sizeof(xl_heap_freeze_tuple) * MaxHeapTuplesPerPage);
+ 
+ 	/*
+ 	 * Note: If you change anything in the loop below, also look at
+ 	 * heap_page_is_all_visible to see if that needs to be changed.
+ 	 */
+ 	for (offnum = FirstOffsetNumber;
+ 		 offnum <= maxoff;
+ 		 offnum = OffsetNumberNext(offnum))
+ 	{
+ 		ItemId		itemid;
+ 		bool		tuple_totally_frozen;
+ 
+ 		itemid = PageGetItemId(page, offnum);
+ 
+ 		if (!ItemIdIsNormal(itemid))
+ 			continue;
+ 
+ 		Assert(ItemIdIsNormal(itemid));
+ 
+ 		tuple.t_data = (HeapTupleHeader) PageGetItem(page, itemid);
+ 		tuple.t_len = ItemIdGetLength(itemid);
+ 		tuple.t_tableOid = RelationGetRelid(relation);
+ 		HeapTupleCopyBaseFromPage(&tuple, page);
+ 
+ 		/*
+ 		 * Each non-removable tuple must be checked to see if it needs
+ 		 * freezing.  Note we already have exclusive buffer lock.
+ 		 */
+ 		if (heap_prepare_freeze_tuple(&tuple, FreezeXid,
+ 									   MultiXactCutoff, &frozen[nfrozen],
+ 									  &tuple_totally_frozen))
+ 			frozen[nfrozen++].offset = offnum;
+ 	}						/* scan along page */
+ 
+ 	/*
+ 	 * If we froze any tuples, mark the buffer dirty, and write a WAL
+ 	 * record recording the changes.  We must log the changes to be
+ 	 * crash-safe against future truncation of CLOG.
+ 	 */
+ 	if (nfrozen > 0)
+ 	{
+ 		int			i;
+ 
+ 		START_CRIT_SECTION();
+ 
+ 		MarkBufferDirty(buffer);
+ 
+ 		/* execute collected freezes */
+ 		for (i = 0; i < nfrozen; i++)
+ 		{
+ 			ItemId		itemid;
+ 			HeapTupleHeader htup;
+ 
+ 			itemid = PageGetItemId(page, frozen[i].offset);
+ 			htup = (HeapTupleHeader) PageGetItem(page, itemid);
+ 
+ 			heap_execute_freeze_tuple_page(page, htup, &frozen[i]);
+ 		}
+ 
+ 		/* Now WAL-log freezing if necessary */
+ 		if (RelationNeedsWAL(relation))
+ 		{
+ 			XLogRecPtr	recptr;
+ 
+ 			recptr = log_heap_freeze(relation, buffer, FreezeXid,
+ 									 frozen, nfrozen);
+ 			PageSetLSN(page, recptr);
+ 		}
+ 
+ 		END_CRIT_SECTION();
+ 	}
+ 
+ 	return nfrozen;
+ }
+ 
+ /*
+  * Ensure that given xid fits base of given page.
+  */
+ bool
+ heap_page_prepare_for_xid(Relation relation, Buffer buffer,
+ 						  TransactionId xid, bool multi)
+ {
+ 	Page				page = BufferGetPage(buffer);
+ 	HeapPageSpecial		pageSpecial = HeapPageGetSpecial(page);
+ 	TransactionId		base;
+ 	bool				found;
+ 	ShortTransactionId	min,
+ 						max;
+ 	int					i;
+ 
+ 	if (!TransactionIdIsNormal(xid))
+ 		return false;
+ 
+ 	for (i = 0; i < 2; i++)
+ 	{
+ 		if (!multi)
+ 			base = pageSpecial->pd_xid_base;
+ 		else
+ 			base = pageSpecial->pd_multi_base;
+ 
+ 		/* Can we already store this xid? */
+ 		if (xid >= base + FirstNormalTransactionId && xid <= base + MaxShortTransactionId)
+ 			return false;
+ 
+ 		/* Find minimum and maximum xids in the page */
+ 		found = heap_page_xid_min_max(page, multi, &min, &max);
+ 
+ 		/* No items on the page? */
+ 		if (!found)
+ 		{
+ 			int64	delta;
+ 
+ 			if (!multi)
+ 				delta = (xid - FirstNormalTransactionId) - pageSpecial->pd_xid_base;
+ 			else
+ 				delta = (xid - FirstNormalTransactionId) - pageSpecial->pd_multi_base;
+ 
+ 			heap_page_shift_base(RelationNeedsWAL(relation) ? buffer : InvalidBuffer,
+ 				page, multi, delta);
+ 			MarkBufferDirty(buffer);
+ 			return false;
+ 		}
+ 
+ 		/* Can we just shift base on the page */
+ 		if (xid < base + FirstNormalTransactionId)
+ 		{
+ 			int64	freeDelta = MaxShortTransactionId - max,
+ 					requiredDelta = (base + FirstNormalTransactionId) - xid;
+ 
+ 			if (requiredDelta <= freeDelta)
+ 			{
+ 				heap_page_shift_base(RelationNeedsWAL(relation) ? buffer : InvalidBuffer,
+ 					page, multi, - (freeDelta + requiredDelta) / 2);
+ 				MarkBufferDirty(buffer);
+ 				return true;
+ 			}
+ 		}
+ 		else
+ 		{
+ 			int64	freeDelta = min - FirstNormalTransactionId,
+ 					requiredDelta = xid - (base + MaxShortTransactionId);
+ 
+ 			if (requiredDelta <= freeDelta)
+ 			{
+ 				heap_page_shift_base(RelationNeedsWAL(relation) ? buffer : InvalidBuffer,
+ 					page, multi, (freeDelta + requiredDelta) / 2);
+ 				MarkBufferDirty(buffer);
+ 				return true;
+ 			}
+ 		}
+ 
+ 		if (i == 1)
+ 		{
+ 			break;
+ 		}
+ 
+ 		/* Have to try freeing the page... */
+ 		freeze_single_heap_page(relation, buffer);
+ 	}
+ 
+ 	elog(ERROR, "Can't fit xid into page.");
+ 	return false;
+ }
+ 
+ /*
+  * Ensure that given xid fits base of given page.
+  */
+ bool
+ rewrite_page_prepare_for_xid(Page page, TransactionId xid, bool multi)
+ {
+ 	HeapPageSpecial		pageSpecial = HeapPageGetSpecial(page);
+ 	TransactionId		base;
+ 	bool				found;
+ 	ShortTransactionId	min,
+ 						max;
+ 
+ 	if (!TransactionIdIsNormal(xid))
+ 		return false;
+ 
+ 	if (!multi)
+ 		base = pageSpecial->pd_xid_base;
+ 	else
+ 		base = pageSpecial->pd_multi_base;
+ 
+ 	/* Can we already store this xid? */
+ 	if (xid >= base + FirstNormalTransactionId && xid <= base + MaxShortTransactionId)
+ 		return false;
+ 
+ 	/* Find minimum and maximum xids in the page */
+ 	found = heap_page_xid_min_max(page, multi, &min, &max);
+ 
+ 	/* No items on the page? */
+ 	if (!found)
+ 	{
+ 		if (!multi)
+ 			pageSpecial->pd_xid_base = xid - FirstNormalTransactionId;
+ 		else
+ 			pageSpecial->pd_multi_base = xid - FirstNormalTransactionId;
+ 		return false;
+ 	}
+ 
+ 	/* Can we just shift base on the page */
+ 	if (xid < base + FirstNormalTransactionId)
+ 	{
+ 		int64	freeDelta = MaxShortTransactionId - max,
+ 				requiredDelta = (base + FirstNormalTransactionId) - xid;
+ 
+ 		if (requiredDelta <= freeDelta)
+ 		{
+ 			heap_page_shift_base(InvalidBuffer,
+ 				page, multi, - (freeDelta + requiredDelta) / 2);
+ 			return true;
+ 		}
+ 	}
+ 	else
+ 	{
+ 		int64	freeDelta = min - FirstNormalTransactionId,
+ 				requiredDelta = xid - (base + MaxShortTransactionId);
+ 
+ 		if (requiredDelta <= freeDelta)
+ 		{
+ 			heap_page_shift_base(InvalidBuffer,
+ 				page, multi, (freeDelta + requiredDelta) / 2);
+ 			return true;
+ 		}
+ 	}
+ 
+ 	elog(ERROR, "Can't fit xid into page.");
+ 	return false;
+ }
+ 
+ 
+ /*
   * Subroutine for heap_insert(). Prepares a tuple for insertion. This sets the
   * tuple header fields, assigns an OID, and toasts the tuple if necessary.
   * Returns a toasted version of the tuple if it was toasted, or the original
*************** heap_insert(Relation relation, HeapTuple
*** 2577,2583 ****
   * the original tuple.
   */
  static HeapTuple
! heap_prepare_insert(Relation relation, HeapTuple tup, TransactionId xid,
  					CommandId cid, int options)
  {
  	/*
--- 3020,3026 ----
   * the original tuple.
   */
  static HeapTuple
! heap_prepare_insert(Relation relation, HeapTuple tup,
  					CommandId cid, int options)
  {
  	/*
*************** heap_prepare_insert(Relation relation, H
*** 2618,2629 ****
  	tup->t_data->t_infomask &= ~(HEAP_XACT_MASK);
  	tup->t_data->t_infomask2 &= ~(HEAP2_XACT_MASK);
  	tup->t_data->t_infomask |= HEAP_XMAX_INVALID;
! 	HeapTupleHeaderSetXmin(tup->t_data, xid);
  	if (options & HEAP_INSERT_FROZEN)
  		HeapTupleHeaderSetXminFrozen(tup->t_data);
  
  	HeapTupleHeaderSetCmin(tup->t_data, cid);
! 	HeapTupleHeaderSetXmax(tup->t_data, 0);		/* for cleanliness */
  	tup->t_tableOid = RelationGetRelid(relation);
  
  	/*
--- 3061,3072 ----
  	tup->t_data->t_infomask &= ~(HEAP_XACT_MASK);
  	tup->t_data->t_infomask2 &= ~(HEAP2_XACT_MASK);
  	tup->t_data->t_infomask |= HEAP_XMAX_INVALID;
! 	tup->t_data->t_choice.t_heap.t_xmin = InvalidTransactionId;
  	if (options & HEAP_INSERT_FROZEN)
  		HeapTupleHeaderSetXminFrozen(tup->t_data);
  
  	HeapTupleHeaderSetCmin(tup->t_data, cid);
! 	HeapTupleSetXmax(tup, 0);		/* for cleanliness */
  	tup->t_tableOid = RelationGetRelid(relation);
  
  	/*
*************** heap_multi_insert(Relation relation, Hea
*** 2676,2683 ****
  	/* Toast and set header data in all the tuples */
  	heaptuples = palloc(ntuples * sizeof(HeapTuple));
  	for (i = 0; i < ntuples; i++)
! 		heaptuples[i] = heap_prepare_insert(relation, tuples[i],
! 											xid, cid, options);
  
  	/*
  	 * Allocate some memory to use for constructing the WAL record. Using
--- 3119,3125 ----
  	/* Toast and set header data in all the tuples */
  	heaptuples = palloc(ntuples * sizeof(HeapTuple));
  	for (i = 0; i < ntuples; i++)
! 		heaptuples[i] = heap_prepare_insert(relation, tuples[i], cid, options);
  
  	/*
  	 * Allocate some memory to use for constructing the WAL record. Using
*************** heap_multi_insert(Relation relation, Hea
*** 2731,2736 ****
--- 3173,3180 ----
  										   &vmbuffer, NULL);
  		page = BufferGetPage(buffer);
  
+ 		heap_page_prepare_for_xid(relation, buffer, xid, false);
+ 
  		/* NO EREPORT(ERROR) from here till changes are logged */
  		START_CRIT_SECTION();
  
*************** heap_multi_insert(Relation relation, Hea
*** 2738,2744 ****
  		 * RelationGetBufferForTuple has ensured that the first tuple fits.
  		 * Put that on the page, and then as many other tuples as fit.
  		 */
! 		RelationPutHeapTuple(relation, buffer, heaptuples[ndone], false);
  		for (nthispage = 1; ndone + nthispage < ntuples; nthispage++)
  		{
  			HeapTuple	heaptup = heaptuples[ndone + nthispage];
--- 3182,3189 ----
  		 * RelationGetBufferForTuple has ensured that the first tuple fits.
  		 * Put that on the page, and then as many other tuples as fit.
  		 */
! 		HeapTupleCopyBaseFromPage(heaptuples[ndone], BufferGetPage(buffer));
! 		RelationPutHeapTuple(relation, buffer, heaptuples[ndone], false, xid);
  		for (nthispage = 1; ndone + nthispage < ntuples; nthispage++)
  		{
  			HeapTuple	heaptup = heaptuples[ndone + nthispage];
*************** heap_multi_insert(Relation relation, Hea
*** 2746,2752 ****
  			if (PageGetHeapFreeSpace(page) < MAXALIGN(heaptup->t_len) + saveFreeSpace)
  				break;
  
! 			RelationPutHeapTuple(relation, buffer, heaptup, false);
  
  			/*
  			 * We don't use heap_multi_insert for catalog tuples yet, but
--- 3191,3198 ----
  			if (PageGetHeapFreeSpace(page) < MAXALIGN(heaptup->t_len) + saveFreeSpace)
  				break;
  
! 			HeapTupleCopyBaseFromPage(heaptup, BufferGetPage(buffer));
! 			RelationPutHeapTuple(relation, buffer, heaptup, false, xid);
  
  			/*
  			 * We don't use heap_multi_insert for catalog tuples yet, but
*************** heap_multi_insert(Relation relation, Hea
*** 2865,2870 ****
--- 3311,3320 ----
  				bufflags |= REGBUF_KEEP_DATA;
  
  			XLogBeginInsert();
+ 			if (info & XLOG_HEAP_INIT_PAGE)
+ 			{
+ 				XLogRegisterData((char *) &HeapPageGetSpecial(page)->pd_xid_base, sizeof(TransactionId));
+ 			}
  			XLogRegisterData((char *) xlrec, tupledata - scratch);
  			XLogRegisterBuffer(0, buffer, REGBUF_STANDARD | bufflags);
  
*************** heap_delete(Relation relation, ItemPoint
*** 3076,3081 ****
--- 3526,3532 ----
  	tp.t_data = (HeapTupleHeader) PageGetItem(page, lp);
  	tp.t_len = ItemIdGetLength(lp);
  	tp.t_self = *tid;
+ 	HeapTupleCopyBaseFromPage(&tp, page);
  
  l1:
  	result = HeapTupleSatisfiesUpdate(&tp, cid, buffer);
*************** l1:
*** 3093,3099 ****
  		uint16		infomask;
  
  		/* must copy state data before unlocking buffer */
! 		xwait = HeapTupleHeaderGetRawXmax(tp.t_data);
  		infomask = tp.t_data->t_infomask;
  
  		/*
--- 3544,3550 ----
  		uint16		infomask;
  
  		/* must copy state data before unlocking buffer */
! 		xwait = HeapTupleGetRawXmax(&tp);
  		infomask = tp.t_data->t_infomask;
  
  		/*
*************** l1:
*** 3133,3139 ****
  				 * for xmax change, and start over if so.
  				 */
  				if (xmax_infomask_changed(tp.t_data->t_infomask, infomask) ||
! 					!TransactionIdEquals(HeapTupleHeaderGetRawXmax(tp.t_data),
  										 xwait))
  					goto l1;
  			}
--- 3584,3590 ----
  				 * for xmax change, and start over if so.
  				 */
  				if (xmax_infomask_changed(tp.t_data->t_infomask, infomask) ||
! 					!TransactionIdEquals(HeapTupleGetRawXmax(&tp),
  										 xwait))
  					goto l1;
  			}
*************** l1:
*** 3166,3172 ****
  			 * Check for xmax change, and start over if so.
  			 */
  			if (xmax_infomask_changed(tp.t_data->t_infomask, infomask) ||
! 				!TransactionIdEquals(HeapTupleHeaderGetRawXmax(tp.t_data),
  									 xwait))
  				goto l1;
  
--- 3617,3623 ----
  			 * Check for xmax change, and start over if so.
  			 */
  			if (xmax_infomask_changed(tp.t_data->t_infomask, infomask) ||
! 				!TransactionIdEquals(HeapTupleGetRawXmax(&tp),
  									 xwait))
  				goto l1;
  
*************** l1:
*** 3180,3186 ****
  		 */
  		if ((tp.t_data->t_infomask & HEAP_XMAX_INVALID) ||
  			HEAP_XMAX_IS_LOCKED_ONLY(tp.t_data->t_infomask) ||
! 			HeapTupleHeaderIsOnlyLocked(tp.t_data))
  			result = HeapTupleMayBeUpdated;
  		else
  			result = HeapTupleUpdated;
--- 3631,3637 ----
  		 */
  		if ((tp.t_data->t_infomask & HEAP_XMAX_INVALID) ||
  			HEAP_XMAX_IS_LOCKED_ONLY(tp.t_data->t_infomask) ||
! 			HeapTupleHeaderIsOnlyLocked(&tp))
  			result = HeapTupleMayBeUpdated;
  		else
  			result = HeapTupleUpdated;
*************** l1:
*** 3200,3206 ****
  			   result == HeapTupleBeingUpdated);
  		Assert(!(tp.t_data->t_infomask & HEAP_XMAX_INVALID));
  		hufd->ctid = tp.t_data->t_ctid;
! 		hufd->xmax = HeapTupleHeaderGetUpdateXid(tp.t_data);
  		if (result == HeapTupleSelfUpdated)
  			hufd->cmax = HeapTupleHeaderGetCmax(tp.t_data);
  		else
--- 3651,3657 ----
  			   result == HeapTupleBeingUpdated);
  		Assert(!(tp.t_data->t_infomask & HEAP_XMAX_INVALID));
  		hufd->ctid = tp.t_data->t_ctid;
! 		hufd->xmax = HeapTupleGetUpdateXidAny(&tp);
  		if (result == HeapTupleSelfUpdated)
  			hufd->cmax = HeapTupleHeaderGetCmax(tp.t_data);
  		else
*************** l1:
*** 3225,3231 ****
  	CheckForSerializableConflictIn(relation, &tp, buffer);
  
  	/* replace cid with a combo cid if necessary */
! 	HeapTupleHeaderAdjustCmax(tp.t_data, &cid, &iscombo);
  
  	/*
  	 * Compute replica identity tuple before entering the critical section so
--- 3676,3682 ----
  	CheckForSerializableConflictIn(relation, &tp, buffer);
  
  	/* replace cid with a combo cid if necessary */
! 	HeapTupleHeaderAdjustCmax(&tp, &cid, &iscombo);
  
  	/*
  	 * Compute replica identity tuple before entering the critical section so
*************** l1:
*** 3243,3253 ****
  	 */
  	MultiXactIdSetOldestMember();
  
! 	compute_new_xmax_infomask(HeapTupleHeaderGetRawXmax(tp.t_data),
  							  tp.t_data->t_infomask, tp.t_data->t_infomask2,
  							  xid, LockTupleExclusive, true,
  							  &new_xmax, &new_infomask, &new_infomask2);
  
  	START_CRIT_SECTION();
  
  	/*
--- 3694,3708 ----
  	 */
  	MultiXactIdSetOldestMember();
  
! 	compute_new_xmax_infomask(HeapTupleGetRawXmax(&tp),
  							  tp.t_data->t_infomask, tp.t_data->t_infomask2,
  							  xid, LockTupleExclusive, true,
  							  &new_xmax, &new_infomask, &new_infomask2);
  
+ 	heap_page_prepare_for_xid(relation, buffer, new_xmax,
+ 		(new_infomask & HEAP_XMAX_IS_MULTI) ? true : false);
+ 	HeapTupleCopyBaseFromPage(&tp, page);
+ 
  	START_CRIT_SECTION();
  
  	/*
*************** l1:
*** 3273,3279 ****
  	tp.t_data->t_infomask |= new_infomask;
  	tp.t_data->t_infomask2 |= new_infomask2;
  	HeapTupleHeaderClearHotUpdated(tp.t_data);
! 	HeapTupleHeaderSetXmax(tp.t_data, new_xmax);
  	HeapTupleHeaderSetCmax(tp.t_data, cid, iscombo);
  	/* Make sure there is no forward chain link in t_ctid */
  	tp.t_data->t_ctid = tp.t_self;
--- 3728,3734 ----
  	tp.t_data->t_infomask |= new_infomask;
  	tp.t_data->t_infomask2 |= new_infomask2;
  	HeapTupleHeaderClearHotUpdated(tp.t_data);
! 	HeapTupleSetXmax(&tp, new_xmax);
  	HeapTupleHeaderSetCmax(tp.t_data, cid, iscombo);
  	/* Make sure there is no forward chain link in t_ctid */
  	tp.t_data->t_ctid = tp.t_self;
*************** heap_update(Relation relation, ItemPoint
*** 3475,3481 ****
  	HeapTuple	heaptup;
  	HeapTuple	old_key_tuple = NULL;
  	bool		old_key_copied = false;
! 	Page		page;
  	BlockNumber block;
  	MultiXactStatus mxact_status;
  	Buffer		buffer,
--- 3930,3937 ----
  	HeapTuple	heaptup;
  	HeapTuple	old_key_tuple = NULL;
  	bool		old_key_copied = false;
! 	Page		page,
! 				newpage;
  	BlockNumber block;
  	MultiXactStatus mxact_status;
  	Buffer		buffer,
*************** heap_update(Relation relation, ItemPoint
*** 3581,3589 ****
--- 4037,4047 ----
  	oldtup.t_data = (HeapTupleHeader) PageGetItem(page, lp);
  	oldtup.t_len = ItemIdGetLength(lp);
  	oldtup.t_self = *otid;
+ 	HeapTupleCopyBaseFromPage(&oldtup, page);
  
  	/* the new tuple is ready, except for this: */
  	newtup->t_tableOid = RelationGetRelid(relation);
+ 	HeapTupleCopyBaseFromPage(newtup, page);
  
  	/* Fill in OID for newtup */
  	if (relation->rd_rel->relhasoids)
*************** l2:
*** 3681,3687 ****
  		 */
  
  		/* must copy state data before unlocking buffer */
! 		xwait = HeapTupleHeaderGetRawXmax(oldtup.t_data);
  		infomask = oldtup.t_data->t_infomask;
  
  		/*
--- 4139,4145 ----
  		 */
  
  		/* must copy state data before unlocking buffer */
! 		xwait = HeapTupleGetRawXmax(&oldtup);
  		infomask = oldtup.t_data->t_infomask;
  
  		/*
*************** l2:
*** 3727,3732 ****
--- 4185,4191 ----
  				checked_lockers = true;
  				locker_remains = remain != 0;
  				LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
+ 				HeapTupleCopyBaseFromPage(&oldtup, page);
  
  				/*
  				 * If xwait had just locked the tuple then some other xact
